//cyc's hoehoe routine (2nd)
//	for the Weakest Othello League
//uhi:D

#ifndef HEADER_CYC2
#define HEADER_CYC2

#include "othello.h"
#include "cyccommo.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <assert.h>

static const int cyc_PT[] = {10,3,3,1,1,3,3,10};

static const int cyc_PP_Orig[]
={ 30 , 2  ,11  , 8  , 8  , 11 ,  2 , 30 ,
   2  , 11 ,11  , 7  , 7  , 11 , 11 ,  2 ,
   11 , 11 , 7  , 4  , 4  , 7  , 11 , 11 ,
   8  , 7  , 4  , 0  , 0  , 4  ,  7 ,  8 ,
   8  , 7  , 4  , 0  , 0  , 4  ,  7 ,  8 ,
   11 , 11 , 7  , 4  , 4  , 7  , 11 , 11 ,
   2  , 11 , 11 , 7  , 7  , 11 , 11 ,  2 ,
   30 , 2  , 11 , 8  , 8  , 11 ,  2 , 30 };

static int cyc_PP[64];

/*origin
static int cyc_PP[]
={ 40 , 1 , 12 , 5  , 5  , 12 ,  1 , 40 ,
   1  , 8 , 7  , 5  , 5  , 7  ,  8 ,  1 ,
   12 , 7 , 6  , 5  , 5  , 6  ,  7 , 12 ,
   5  , 5 , 5  , 0  , 0  , 5  ,  5 ,  5 ,
   5  , 5 , 5  , 0  , 0  , 5  ,  5 ,  5 ,
   12 , 7 , 6  , 5  , 5  , 6  ,  7 , 12 ,
   1  , 8 , 7  , 5  , 5  , 7  ,  8 ,  1 ,
   40 , 1 , 12 , 5  , 5  , 12 ,  1 , 40 };
*/


static
int
positionPoint
(int src)	//position
{
	return cyc_PP[src];
}

static
int
checkPosition
(char *mSrcBoard,	//TargetBoard
 int x,				//x
 int y)				//y
{
	return mSrcBoard[cyc_tbl (x,y)];
}

static const int cyc_PT3[] = {0,2,1,2,5,3,1,3,4};

static
int
checkPosition2
(char *mSrcBoard,	//TargetBoard
 int x1,			//x1
 int y1,			//y1
 int x2,			//x2
 int y2)			//y2
{
	// nn = 0
	// n*,*n= 2 nx,xn=1
	// x*,*x= 3 xx=4 **=5;
	int mRetP=0;

	assert((x1>-1)&&(x1<8)&&
		   (x2>-1)&&(x2<8)&&
		   (y1>-1)&&(y1<8)&&
		   (y2>-1)&&(y2<8));

	mRetP=cyc_PT3[
		mSrcBoard[cyc_tbl(x1,y1)]*3+mSrcBoard[cyc_tbl(x2,y2)]];
//	printf("(deb:x%d,y%d(%d),x%d,y%d(%d):%d)",x1,y1,mSrcBoard[cyc_tbl(x1,y1)],mSrcBoard[cyc_tbl(x2,y2)],x2,y2,mRetP);
	return mRetP;
}

static
void
changeTable
(char	*mSrcBoard)			//TargetBoard
{
	//1check

	int check3=6;
	int check4=3;
	int check6=10;
	int check8=5;

	if (checkPosition(mSrcBoard,1,0)==1)
	{
		cyc_PP[cyc_tbl(2,0)]=check8;
		cyc_PP[cyc_tbl(3,0)]=check3;
		if (checkPosition(mSrcBoard,2,0)==0)
			cyc_PP[cyc_tbl(3,0)]=check6;
	}
	if (checkPosition(mSrcBoard,1,0)!=0)
	{
		cyc_PP[cyc_tbl(2,1)]=check4;
	}
	
	if (checkPosition(mSrcBoard,0,1)==1)
	{
		cyc_PP[cyc_tbl(0,2)]=check8;
		cyc_PP[cyc_tbl(0,3)]=check3;
		if (checkPosition(mSrcBoard,0,2)==0)
			cyc_PP[cyc_tbl(0,3)]=check6;
	}
	if (checkPosition(mSrcBoard,0,1)!=0)
	{
		cyc_PP[cyc_tbl(1,2)]=check4;
	}

	if (checkPosition(mSrcBoard,6,0)==1)
	{
		cyc_PP[cyc_tbl(5,0)]=check8;
		cyc_PP[cyc_tbl(4,0)]=check3;
		if (checkPosition(mSrcBoard,5,0)==0)
			cyc_PP[cyc_tbl(4,0)]=check6;
	}
	if (checkPosition(mSrcBoard,6,0)!=0)
	{
		cyc_PP[cyc_tbl(5,1)]=check4;
	}
	
	if (checkPosition(mSrcBoard,7,1)==1)
	{
		cyc_PP[cyc_tbl(7,2)]=check8;
		cyc_PP[cyc_tbl(7,3)]=check3;
		if (checkPosition(mSrcBoard,7,2)==0)
			cyc_PP[cyc_tbl(7,3)]=check6;
	}
	if (checkPosition(mSrcBoard,7,1)!=0)
	{
		cyc_PP[cyc_tbl(6,2)]=check4;
	}
	
	if (checkPosition(mSrcBoard,0,6)==1)
	{
		cyc_PP[cyc_tbl(0,5)]=check8;
		cyc_PP[cyc_tbl(0,4)]=check3;
		if (checkPosition(mSrcBoard,0,5)==0)
			cyc_PP[cyc_tbl(0,4)]=check6;
	}
	if (checkPosition(mSrcBoard,0,6)!=0)
	{
		cyc_PP[cyc_tbl(1,5)]=check4;
	}

	if (checkPosition(mSrcBoard,1,7)==1)
	{
		cyc_PP[cyc_tbl(2,7)]=check8;
		cyc_PP[cyc_tbl(3,7)]=check3;
		if (checkPosition(mSrcBoard,2,7)==0)
			cyc_PP[cyc_tbl(3,7)]=check6;
	}
	if (checkPosition(mSrcBoard,1,7)!=0)
	{
		cyc_PP[cyc_tbl(2,6)]=check4;
	}
	
	if (checkPosition(mSrcBoard,7,6)==1)
	{
		cyc_PP[cyc_tbl(7,5)]=check8;
		cyc_PP[cyc_tbl(7,4)]=check3;
		if (checkPosition(mSrcBoard,7,5)==0)
			cyc_PP[cyc_tbl(7,4)]=check6;
	}
	if (checkPosition(mSrcBoard,7,6)!=0)
	{
		cyc_PP[cyc_tbl(6,5)]=check4;
	}
	
	if (checkPosition(mSrcBoard,6,7)==1)
	{
		cyc_PP[cyc_tbl(5,7)]=check8;
		cyc_PP[cyc_tbl(4,7)]=check3;
		if (checkPosition(mSrcBoard,5,7)==0)
			cyc_PP[cyc_tbl(4,7)]=check6;
	}
	if (checkPosition(mSrcBoard,6,7)!=0)
	{
		cyc_PP[cyc_tbl(5,6)]=check4;
	}
	
    //1-1 check

	int check1=3;
	int check2=1;
	int check5=4;
	int check7=4;
	
	if (checkPosition2(mSrcBoard,1,0,0,1)==5)
	{
		cyc_PP[cyc_tbl(1,1)]=check2;
		cyc_PP[cyc_tbl(2,0)]=check1;
		cyc_PP[cyc_tbl(0,2)]=check1;
		cyc_PP[cyc_tbl(2,1)]=check7;
		cyc_PP[cyc_tbl(1,2)]=check7;
		if (checkPosition(mSrcBoard,1,1)!=0)
		{
			cyc_PP[cyc_tbl(2,0)]=check2;
			cyc_PP[cyc_tbl(0,2)]=check2;
		}
	}
	if (checkPosition2(mSrcBoard,1,0,0,1)==4)
	{
		cyc_PP[cyc_tbl(1,1)]=check2;
		cyc_PP[cyc_tbl(2,0)]=check5;
		cyc_PP[cyc_tbl(0,2)]=check5;
		cyc_PP[cyc_tbl(2,1)]=check5;
		cyc_PP[cyc_tbl(1,2)]=check5;
	}

	if (checkPosition2(mSrcBoard,6,0,7,1)==5)
	{
		cyc_PP[cyc_tbl(6,1)]=check2;
		cyc_PP[cyc_tbl(5,0)]=check1;
		cyc_PP[cyc_tbl(7,2)]=check1;
		cyc_PP[cyc_tbl(5,1)]=check7;
		cyc_PP[cyc_tbl(6,2)]=check7;
		if (checkPosition(mSrcBoard,6,1)!=0)
		{
			cyc_PP[cyc_tbl(5,0)]=check2;
			cyc_PP[cyc_tbl(7,2)]=check2;
		}
	}
	if (checkPosition2(mSrcBoard,6,0,7,1)==4)
	{
		cyc_PP[cyc_tbl(6,1)]=check2;
		cyc_PP[cyc_tbl(5,0)]=check5;
		cyc_PP[cyc_tbl(7,2)]=check5;
		cyc_PP[cyc_tbl(5,1)]=check5;
		cyc_PP[cyc_tbl(6,2)]=check5;
	}

	if (checkPosition2(mSrcBoard,0,6,1,7)==5)
	{
		cyc_PP[cyc_tbl(1,6)]=check2;
		cyc_PP[cyc_tbl(0,5)]=check1;
		cyc_PP[cyc_tbl(2,7)]=check1;
		cyc_PP[cyc_tbl(1,5)]=check7;
		cyc_PP[cyc_tbl(2,6)]=check7;
		if (checkPosition(mSrcBoard,1,6)!=0)
		{
			cyc_PP[cyc_tbl(0,5)]=check2;
			cyc_PP[cyc_tbl(2,7)]=check2;
		}
	}
	if (checkPosition2(mSrcBoard,0,6,1,7)==4)
	{
		cyc_PP[cyc_tbl(1,6)]=check2;
		cyc_PP[cyc_tbl(0,5)]=check5;
		cyc_PP[cyc_tbl(2,7)]=check5;
		cyc_PP[cyc_tbl(1,5)]=check5;
		cyc_PP[cyc_tbl(2,6)]=check5;
	}
	
	if (checkPosition2(mSrcBoard,7,6,6,7)==5)
	{
		cyc_PP[cyc_tbl(6,6)]=check2;
		cyc_PP[cyc_tbl(7,5)]=check1;
		cyc_PP[cyc_tbl(5,7)]=check1;
		cyc_PP[cyc_tbl(6,5)]=check7;
		cyc_PP[cyc_tbl(5,6)]=check7;
		if (checkPosition(mSrcBoard,6,6)!=0)
		{
			cyc_PP[cyc_tbl(7,5)]=check2;
			cyc_PP[cyc_tbl(5,7)]=check2;
		}
	}
	if (checkPosition2(mSrcBoard,7,6,6,7)==4)
	{
		cyc_PP[cyc_tbl(6,6)]=check2;
		cyc_PP[cyc_tbl(7,5)]=check5;
		cyc_PP[cyc_tbl(5,7)]=check5;
		cyc_PP[cyc_tbl(6,5)]=check5;
		cyc_PP[cyc_tbl(5,6)]=check5;
	}
}

static
int							//Point
recursiveNextCheck2
(char		*mSrcBoard,		//Target Board
 int		mColor,			//Target Point
 int		mLoop,			//Target Color
 int		&mPosition,		//Next
 int		mPassFlag		//PassFlag
 )
{
	int mMaxPoint=-99;
	int mMinPoint=99;
	int mMaxLoc=99;
	int mMinLoc=99;
	
	for (int i=0;i<64;i++)
	{
		char mTestBoard[64];
		CopyBoard(mSrcBoard,mTestBoard,NORM);
	    int mTmpPoint=Put(mTestBoard,i,mColor,NOT_CHANGE);
		if (mTmpPoint)
		{
			Put(mTestBoard,i,mColor,CHANGE);
			int mPoint;
			int mTest;
//	C_PRINTF(("(%d)%d,%d)",mLoop,cyc_tblx(i),cyc_tbly(i)));
			mPoint=recursiveNextCheck2(mTestBoard,3-mColor,mLoop-1,mTest,0);
			if (mPoint<mMinPoint)
			{
//				printf("checkMin(%d,%d)\n",mLoop,mPoint);
				mMinPoint=mPoint;
				mMinLoc=i;
			}
			if (mPoint>mMaxPoint)
			{
//				printf("checkMax(%d,%d)\n",mLoop,mPoint);
				mMaxPoint=mPoint;
				mMaxLoc=i;
			}
		}
	}

	if ((mLoop<1)||
		((mMaxLoc==99)&&(mMinLoc==99)&&(mPassFlag)))
	{
		//end
		int mCounter1;
		int mCounter2;
		CountDisks(mSrcBoard,&mCounter1,&mCounter2);
		int mCounter=mCounter1-mCounter2;
//		printf("MC:%d\n",mCounter);
		return mCounter;
	}

	if 	((mMaxLoc==99)&&(mMinLoc==99))
	{
		int mTest;
		int mPoint=recursiveNextCheck2(mSrcBoard,3-mColor,mLoop-1,mTest,1);
		if (mPoint<mMinPoint)
		{
			mMinPoint=mPoint;
			mMinLoc=99;
		}
		if (mPoint>mMaxPoint)
		{
			mMaxPoint=mPoint;
			mMaxLoc=99;
		}
	}

	switch (mColor)
	{
	case OP_COLOR:
		mPosition=mMaxLoc;
//		C_PRINTF(("MY(%d)%d,%d) point:%d\n",mLoop,cyc_tblx(mPosition),cyc_tbly(mPosition),mMaxPoint));
		return mMaxPoint;
	case MY_COLOR:
		mPosition=mMinLoc;
//		C_PRINTF(("OP(%d)%d,%d) point:%d\n",mLoop,cyc_tblx(mPosition),cyc_tbly(mPosition),mMaxPoint));
		return mMinPoint;
	default:
		abort();
	}
}

static
int
recursiveNextCheck
(char		*mSrcBoard		//Target Board
 )
{
	int mRetP;
	recursiveNextCheck2(mSrcBoard,MY_COLOR,99,mRetP,0);
	return mRetP;
}

static
int
recursivePointCheck
(char 		*mSrcBoard,		//Target Board
 int		mTargetPoint,	//Target Point
 int		mColor,			//Target Color
 int		mLoop			//Loop counter
 )
{
	if (mLoop==0) return 0;

	char mTestBoard[64];
	CopyBoard(mSrcBoard,mTestBoard,NORM);
	Put(mTestBoard,mTargetPoint,mColor,CHANGE);
	int mMinOppPoint=0;
	int mMaxMyPoint=0;
	
	for (int i=0;i<64;i++)
	{
	    int mTmpPoint=Put(mTestBoard,i,3-mColor,NOT_CHANGE);
		if (mTmpPoint)
		{
			mTmpPoint*=cyc_PP[i];
			switch (mColor)
			{
			case OP_COLOR:
				mTmpPoint+=recursivePointCheck(mTestBoard,i,MY_COLOR,mLoop-1);
				if (mTmpPoint>mMaxMyPoint) mMaxMyPoint=mTmpPoint;
				break;
			case MY_COLOR:
				mTmpPoint+=recursivePointCheck(mTestBoard,i,OP_COLOR,mLoop-1);
				if (mTmpPoint&&(!mMinOppPoint)) mMinOppPoint=mTmpPoint;
				if (mTmpPoint<mMinOppPoint) mMinOppPoint=mTmpPoint;
				break;
			}
		}
	}

	switch (mColor)
	{
	case MY_COLOR:
		return mMinOppPoint*10;
	case OP_COLOR:
		return 0-mMaxMyPoint;
	default:
		abort();
	}
}

static
int
recursiveMapCheck
(char 		*mSrcBoard,		//Target Board
 int		mTargetPoint,	//Target Point
 int		mColor,			//Target Color
 int		mLoop			//Loop counter
 )
{
	if (mLoop==0) return 0;

	char mTestBoard[64];
	CopyBoard(mSrcBoard,mTestBoard,NORM);
	int mPoint=0;

	//core1
	int i;
   	for (i=0;i<64;i++)
	{
		switch (mTestBoard[i])
		{
		case OP_COLOR:
			mPoint-=cyc_PP[i]*cyc_PP[i]*cyc_PP[i];
			break;
		case MY_COLOR:
			mPoint+=cyc_PP[i]*cyc_PP[i]*cyc_PP[i];
			break;
		}
	}

	int mCounter1;
	int mCounter2;
	CountDisks(mTestBoard,&mCounter1,&mCounter2);
	int mCounter=mCounter1+mCounter2;
	
	Put(mTestBoard,mTargetPoint,mColor,CHANGE);

	//core2

	int mPoint2=0;
	
	for (i=0;i<64;i++)
	{
		switch (mTestBoard[i])
		{
		case OP_COLOR:
			mPoint2-=cyc_PP[i]*cyc_PP[i]*cyc_PP[i];
			break;
		case MY_COLOR:
			mPoint2+=cyc_PP[i]*cyc_PP[i]*cyc_PP[i];
			break;
		}
	}

	int mPointDiff=mPoint2-mPoint;	
	
	mPointDiff*=mCounter*mCounter;
	mPointDiff/=400;

	int mTP=cyc_PP[mTargetPoint];
	switch (mColor)
	{
	case OP_COLOR:
		mPointDiff-=mTP*mTP*mTP;
		break;
	case MY_COLOR:
		mPointDiff*=mTP;
		break;
	}

	return mPointDiff;
}

extern "C"
int				//NextPoint
cyc2
(char	*board,	//board
 int	status)	//status (norm,passp,initp)
{

	if (initp(status))
	{
		memcpy(&cyc_PP,&cyc_PP_Orig,sizeof(cyc_PP));
	}
	if(passp(status) || initp(status))
		return 0;

	int mPoint=0;
	int mMinPoint=0;
	int mNextPoint=0;

	changeTable(board);

	int mCounter1;
	int mCounter2;
	CountDisks(board,&mCounter1,&mCounter2);
	int mCounter=mCounter1+mCounter2;
	if ((64-mCounter)<9) return recursiveNextCheck(board);

	for (int i=0;i<64;i++)
	{
		int mGetPoint=Put(board,i,MY_COLOR,NOT_CHANGE);
		if ( mGetPoint>0 )
		{
			int mX1=cyc_tblx(i);
			int mY1=cyc_tbly(i);
			//int mXP=centerPoint(mX1);
			//int mYP=centerPoint(mY1);
			int mP=positionPoint(i);

			mPoint=0;
			
			for (int j=0;j<64;j++)
			{
				int mTmpPoint=0;
				int mX2=cyc_tblx(j);
				int mY2=cyc_tbly(j);

				int mX3=abs(mX1-mX2);
				int mY3=abs(mY1-mY2);

				if (board[j]==CYC_MY)
					mTmpPoint+=(mX3*mX3+mY3*mY3)/4;
				mPoint+=mTmpPoint;
			}
			
			mPoint+=mP*mP*mP*mP+1;

			mPoint*=mGetPoint;

			//cyc2 original

			int mNewPoint=recursivePointCheck(board,i,MY_COLOR,2);

			if (mNewPoint)
			{
				/*
				   mNewPoint/=400;
				if(mNewPoint>0)
					mPoint*=mNewPoint;
				else
				{
					if(mNewPoint<0)
					{
						mPoint/=abs(mNewPoint);
					}
					}
					*/
				mPoint+=mNewPoint;
			}

//			C_PRINTF(("(iyanayokan:%d)",mPoint));

			int mNewPoint2=recursiveMapCheck(board,i,MY_COLOR,2);
			
			mPoint+=mNewPoint2;
			
			if(mPoint<1) mPoint=1;
			
				C_PRINTF(("DD2)Check:%d,%d ->Min:%d Get:%d mP:%d nP:%d nP2:%d\n",
						  cyc_tblx(i),
						  cyc_tbly(i),
						  mPoint,
						  mGetPoint,
						  mP,
						  mNewPoint,
						  mNewPoint2));
			
			if (mMinPoint==0)
			{
				mMinPoint=mPoint;
				mNextPoint=i;
				C_PRINTF(("Start\n"));
				C_PRINTF(("2)Check:%d,%d ->Min:%d Get:%d mP:%d nP:%d nP2:%d\n",
						  cyc_tblx(mNextPoint),
						  cyc_tbly(mNextPoint),
						  mMinPoint,
						  mGetPoint,
						  mP,
						  mNewPoint,
						  mNewPoint2));
			}
			else
			{
				if (mPoint<mMinPoint)
				{
					mMinPoint=mPoint;
					mNextPoint=i;

					C_PRINTF(("2)Check:%d,%d ->Min:%d Get:%d mP:%d nP:%d nP2:%d\n",
							  cyc_tblx(mNextPoint),
							  cyc_tbly(mNextPoint),
							  mMinPoint,
							  mGetPoint,
							  mP,
							  mNewPoint,
							  mNewPoint2));
				}
			}
		}
	}
	
	C_PRINTF(("Go:%d,%d\n",cyc_tblx(mNextPoint),cyc_tbly(mNextPoint)));

	if (mMinPoint==0) return (-1);
	return mNextPoint;
}

#endif //#define HEADER_CYC2


